// CaptureImageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CaptureImage.h"
#include "CaptureImageDlg.h"

#ifdef _WIN64
#include "okapi64.h"
#else
#include "okapi32.h"
#endif


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HWND hWnd;
HANDLE hBoard;
LPBITMAPINFOHEADER	lpbi;
LPBYTE				lpdib;
BLOCKINFO	blk;

char		string[20];
long		num=0;
DWORD		times=0;
float		ratio=25;//֡
int         avi=0;   //¼־
int			JPG=0;//ͼ־
char		caviFilePass[300];
BOOL		bTrig=0;
int			isharpparam=0;
int			iTransParam=0;
CWnd*		cWnd;
CString     sPath;
BOOL		symbol;
RECT	imageRect;
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form);
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height);
float exCalcCaptureRatio(long *num,DWORD *times);
BOOL exConvertBitmap(LPBITMAPINFOHEADER lpbi,LPSTR lpdib);
BOOL CALLBACK BeginCapture(HANDLE hBoard);
BOOL CALLBACK Process(HANDLE hBoard, MLONG  no);
BOOL CALLBACK EndCapture(HANDLE hBoard);

/////////////////////////////////////////////////////////////////////////////
// CCaptureImageDlg dialog

CCaptureImageDlg::CCaptureImageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCaptureImageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCaptureImageDlg)
	m_sharp = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_OKDEMO);
}

void CCaptureImageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCaptureImageDlg)
	DDX_Control(pDX, IDC_IMAGE, m_image);
	DDX_CBIndex(pDX, IDC_COMBO1, m_sharp);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCaptureImageDlg, CDialog)
	//{{AFX_MSG_MAP(CCaptureImageDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_JPG, OnJpg)
	ON_BN_CLICKED(IDC_AVIFILE, OnAvifile)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK, OnCheck)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCaptureImageDlg message handlers

BOOL CCaptureImageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//***************************************************************//
	//************ open card and initialize the application *********//
	MLONG 	lIndex=-1;

	hBoard=okOpenBoard(&lIndex);
//	okSetCaptureParam(hBoard,CAPTURE_CLIPMODE,0);
 //	okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,FORM_GRAY8);
	imageRect.right=-1;
	okSetTargetRect(hBoard,BUFFER,&imageRect);
	lpbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,imageRect.right*imageRect.bottom*4+5120);//ڴʾͼ񣬸ҪʵԭʼݵĶڴĴС
	lpdib=(LPBYTE)lpbi+5120;
	hWnd=AfxGetApp()->m_pMainWnd->m_hWnd;
//	AfxGetApp()->m_pMainWnd->ShowWindow(SW_MAXIMIZE);
	SetWindowText("OKۺʾ");
	SetTimer(234,40,NULL);//ʱⴥźţ̶ӦΪͼ


	CComboBox* m_combo=(CComboBox *)GetDlgItem(IDC_COMBO1);
	m_combo->SetCurSel(0);
	m_combo=(CComboBox *)GetDlgItem(IDC_COMBO2);
	m_combo->SetCurSel(2);
	GetDlgItem(IDC_STOP)->EnableWindow(FALSE);
	GetDlgItem(IDC_JPG)->EnableWindow(FALSE);

	cWnd = GetDlgItem(IDC_IMAGE);
	cWnd->GetWindowRect(&imageRect);
	ScreenToClient(&imageRect);	
	imageRect.right = imageRect.left +768;
	imageRect.bottom = imageRect.top + 576;

	int picWidth=768;
	int picHeight=576;	
	cWnd->MoveWindow(imageRect.left, imageRect.top, picWidth, picHeight, FALSE);
	 		
	GetModuleFileName(NULL,sPath.GetBufferSetLength(MAX_PATH+1),MAX_PATH); 	//óеĵǰ·	
	sPath.ReleaseBuffer();   
	int    nPos;   		
	nPos=sPath.ReverseFind('\\');  		
	sPath=sPath.Left(nPos);
	

	
	//***************************************************************//
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCaptureImageDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDC *cdc;
		RECT rect;
		
		cdc=m_image.GetDC();
		
		m_image.GetClientRect(&rect);
		SetStretchBltMode(cdc->m_hDC,STRETCH_DELETESCANS);
		StretchDIBits(cdc->m_hDC,
			rect.left,rect.top,
			rect.right,rect.bottom, 
			0,0, //horzstart, vertstart, 
			lpbi->biWidth,lpbi->biHeight,
			lpdib,(LPBITMAPINFO)lpbi, 
			DIB_RGB_COLORS,SRCCOPY);
		
 		ReleaseDC(cdc);
		
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCaptureImageDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCaptureImageDlg::OnStart() 
{
//	RECT rect;

//	SetRect(&rect,0,0,768,576);
//	okSetTargetRect(hBoard,BUFFER,&rect);

	okSetSeqCallback(hBoard,BeginCapture,Process,EndCapture);
	okCaptureTo(hBoard,BUFFER,0,-1);
	// 	okCaptureSequence(hBoard,0,-1);
// 	UpdateData(FALSE);
// 	isharpparam=m_sharp;
	CComboBox* m_combo=(CComboBox *)GetDlgItem(IDC_COMBO1);
	int nselect=m_combo->GetCurSel();
	
	if (nselect==0)
		isharpparam=0;
	else if(nselect==1)
		isharpparam=1;
	else if(nselect==2)
		isharpparam=2;
	else if (nselect==3)
		isharpparam=3;
	else if(nselect==4)
		isharpparam=4;
	
	m_combo=(CComboBox *)GetDlgItem(IDC_COMBO2);
	nselect=m_combo->GetCurSel();
	
	if (nselect==0)
		iTransParam=3;
	else if(nselect==1)
		iTransParam=5;
	else if(nselect==2)
		iTransParam=0;
	else 
		iTransParam=0;
	
	okSetConvertParam(hBoard,CONVERT_FIELDEXTEND,iTransParam);
	GetDlgItem(IDC_COMBO1)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO2)->EnableWindow(FALSE);
	GetDlgItem(IDC_STOP)->EnableWindow(TRUE);
	GetDlgItem(IDC_AVIFILE)->EnableWindow(FALSE);
	GetDlgItem(IDC_START)->EnableWindow(FALSE);
	GetDlgItem(IDC_JPG)->EnableWindow(TRUE);

}

void CCaptureImageDlg::OnClose() 
{
	KillTimer(234);
	okStopCapture(hBoard);
	okCloseBoard(hBoard);
	GlobalFree(lpbi);
	
	CDialog::OnClose();
}

//****************CALLBACK FUNCTION***********************************
BOOL CALLBACK BeginCapture(HANDLE hBoard)
{
	short		width,height;
	long		form;
	
	exGetTargetSize(hBoard, BUFFER, &width, &height);         //DIBļͷ
  	form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
	exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );
	blk.lpBits=lpdib;
	blk.iBitCount=lpbi->biBitCount;
	blk.iHeight =(short)lpbi->biHeight;
	blk.iWidth =(short)lpbi->biWidth;
	blk.lpExtra=(LPBYTE)lpbi+lpbi->biSize;


	if (avi==1)                //ǴaviļԤļ
	{
		char  avinameall[500];
		sprintf(avinameall,"%s,mjpg,beg",caviFilePass);
		okSaveImageFile(hBoard,avinameall,0,BUFFER,0,1);
	}
	return 1;
}

BOOL CALLBACK Process(HANDLE hBoard,MLONG  no)
{	
	char  avinameall[500];  //ͼڸúн
	LPBYTE	lpbuf;
	short	height;
	MLONG 	stride;
	int		i;

	sprintf(string,"%5.2f",exCalcCaptureRatio(&num,&times));   //ʾ֡
	AfxGetApp()->m_pMainWnd->SetDlgItemText(IDC_STATIC,string);

	lpbuf=(LPBYTE)okGetTargetInfo(hBoard,BUFFER,no,NULL,&height,&stride); //õǰ֡ĵַͼݵ
	if (symbol==1) 
	{	
		//
		for(i=0;i<=height*stride;i++)
		{
			*(lpbuf+i)=255-(*(lpbuf+i));
		}		
	}
	if (isharpparam!=0)
	{
		okSharpFilter(hBoard,BUFFER,no,isharpparam);       //񻯴
	}
	if (IsDlgButtonChecked(hWnd,IDC_GUASS))
	{
		okGuassFilter(hBoard,BUFFER,no);                   //˹˲
	}
	okConvertRect(hBoard,(TARGET)&blk,0,BUFFER,no,1);      //ݵDIB׼ʾͬʱoksetconvertparamòͬ
	                                                        //Խݳתȥżλ⡣
	                                                        //ļݶת֤֮洢ûݳݡ
	if (avi==1)                            //дļ
	{
		sprintf(avinameall,"%s,mjpg,con",caviFilePass);
		okSaveImageFile(hBoard,avinameall,0,(TARGET)&blk,0,1);

	} 
	if(JPG==1)                 //jpgͼ
	{
		SYSTEMTIME sys;
		GetLocalTime( &sys ); 
		char	szFileName[300];
		memset(szFileName,0,50);
		sprintf(szFileName,"%s\\%02d%02d%02d.jpg",sPath,sys.wHour,sys.wMinute,sys.wSecond);	
		okSaveImageFile(hBoard,szFileName,0,(TARGET)&blk,0,1); 
		JPG=0;
	}
	if (bTrig==1)                      //дźţ򱣴һͼ
	{
		SYSTEMTIME sys;
		GetLocalTime( &sys ); 
		char	szFileName[300];
		memset(szFileName,0,50);
		sprintf(szFileName,"%s\\trig%02d%02d%02d.jpg",sPath,sys.wHour,sys.wMinute,sys.wSecond);	
		okSaveImageFile(hBoard,szFileName,0,(TARGET)&blk,0,1);
		bTrig=0;

	}
	exConvertBitmap(lpbi,(char *)lpdib);
 	InvalidateRect(hWnd,&imageRect,FALSE);               
	UpdateWindow(GetDlgItem(hWnd,IDC_IMAGE));                                  //ˢϢʾ²ɼͼ
	
	return 1;
}

BOOL CALLBACK EndCapture(HANDLE hBoard)
{
	okSetSeqCallback(hBoard,NULL,NULL,NULL);
	if (avi==1)
	{
		char  avinameall[500];
		sprintf(avinameall,"%s,mjpg,end",caviFilePass);
		okSaveImageFile(hBoard,avinameall,0,BUFFER,0,1);
		avi=0;
	}

	return 1;
}
//********************************************************************
float exCalcCaptureRatio(long *num,DWORD *times)
{
	if( (*num>=12) || ((okGetTickCount()-(*times))>2000) ) 
	{
		*times=okGetTickCount()-(*times);
		ratio=((float)(*num)*1000/(*times));
		*num=0;
	}
	
	if(*num==0)
		(*times)=okGetTickCount();
	(*num)++;
	
	return ratio;
}

long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height)
{
	RECT	rect;
	long	form;


	if( (tgt==SCREEN ) ||(tgt==BUFFER) ) {
		rect.right=-1;
		okSetTargetRect(hBoard,tgt,&rect); //get current rect
		if(width)
			*width=(short)(rect.right-rect.left);
		if(height)
			*height=(short)(rect.bottom-rect.top);

		if(tgt==SCREEN ) {
			form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
			//limit to video rect
			rect.right=-1; //max. captured rect
			okSetTargetRect(hBoard,VIDEO,&rect); //get video rect
			if(width)
				*width=(short)min(*width,rect.right-rect.left);
			if(height)
				*height=(short)min(*height,rect.bottom-rect.top);
		}
		else if(tgt==BUFFER) 
			form=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM); //-1

	} else if(tgt>BUFFER) { //from blkinfo
		LPBLOCKINFO	lpblk;
		lpblk=(LPBLOCKINFO)tgt;

		if(width)
			*width=lpblk->iWidth;
		if(height)
			*height=abs(lpblk->iHeight);
		form=MAKELONG(lpblk->iFormType,lpblk->iBitCount);
	}


	return form;
}

long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
	long	wbytes;

	if(!lpbi)
		return FALSE;

	
	if(form==FORM_RGB555)
		bits=16;
	wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align

	lpbi->biWidth=width;
	lpbi->biHeight=height;

	lpbi->biSize=sizeof(BITMAPINFOHEADER);
	lpbi->biPlanes=1;

	lpbi->biBitCount=bits;
	lpbi->biSizeImage=wbytes*height;


	lpbi->biClrUsed=0;
	//special format for 555,565 & 32 
	if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 ) 
		lpbi->biCompression=BI_BITFIELDS;
	else
		lpbi->biCompression=0;
	if(lpbi->biCompression==BI_BITFIELDS ) {//
		DWORD	*lpmask;
		lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);

		if(form==FORM_RGB555) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x03e0;
			lpmask[0]=0x7c00;
		}
		else if(form==FORM_RGB565) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x07e0;
			lpmask[0]=0xf800;
		}
		else if(bits==32 ) {
			lpmask[2]=0x0000ff;
			lpmask[1]=0x00ff00;
			lpmask[0]=0xff0000;
		}
	}
	else if(bits<=14) { // 8,10,12
		int		i,ratio;
		RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);

		lpbi->biClrUsed=(1<<bits);
		ratio=lpbi->biClrUsed/256;

		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=i/ratio;
			lpRGB[i].rgbGreen=i/ratio;
			lpRGB[i].rgbRed=i/ratio;
			lpRGB[i].rgbReserved=0;
		}
	
	} 
	lpbi->biClrImportant=lpbi->biClrUsed;

	return lpbi->biClrUsed;
}



void CCaptureImageDlg::OnStop() 
{
	okStopCapture(hBoard);
// 	okSetSeqCallback(hBoard,NULL,NULL,NULL);
// 	if(avi==1)
// 	{
// 		okSaveImageFile(hBoard,"image.avi,mjpg,end",0,BUFFER,0,1);
// 		avi=0;
// 	}
	GetDlgItem(IDC_COMBO1)->EnableWindow(TRUE);
	GetDlgItem(IDC_COMBO2)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP)->EnableWindow(FALSE);
	GetDlgItem(IDC_AVIFILE)->EnableWindow(TRUE);
	GetDlgItem(IDC_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_JPG)->EnableWindow(FALSE);

}

void CCaptureImageDlg::OnJpg() 
{
	JPG=1;
}

void CCaptureImageDlg::OnAvifile() 
{
	memset(caviFilePass,0,300); //ַ
	okStopCapture(hBoard);
	CFileDialog file(FALSE,"*.avi",NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Compressed AVI in MJPEG (*.avi)|*.avi||");// LPCTSTR lpszDefExt = NULL, LPCTSTR lpszFileName = NULL, DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, LPCTSTR lpszFilter = NULL, CWnd* pParentWnd = NULL );
	if (file.DoModal()==IDOK)
	{
		CString   strFile   =   file.GetPathName();
	//	CString   strPath   =   strFile.Left(strFile.ReverseFind('\\')+1);
		strcpy(caviFilePass,strFile);
	}
	else
	{
		MessageBox("ָļƼ·ʧܣ",NULL,MB_OK);
		return;
	}
	avi=1;
	okStopCapture(hBoard);
	CComboBox* m_combo=(CComboBox *)GetDlgItem(IDC_COMBO1);          
	int nselect=m_combo->GetCurSel();
	
	if (nselect==0)
		isharpparam=0;
	else if(nselect==1)
		isharpparam=1;
	else if(nselect==2)
		isharpparam=2;
	else if (nselect==3)
		isharpparam=3;
	isharpparam=0;
	
	m_combo=(CComboBox *)GetDlgItem(IDC_COMBO2);
	nselect=m_combo->GetCurSel();
	
	if (nselect==0)
		iTransParam=3;
	else if(nselect==1)
		iTransParam=5;
	else if(nselect==2)
		iTransParam=0;
	else 
		iTransParam=0;
	
	okSetConvertParam(hBoard,CONVERT_FIELDEXTEND,iTransParam);

	GetDlgItem(IDC_COMBO1)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO2)->EnableWindow(FALSE);
	GetDlgItem(IDC_AVIFILE)->EnableWindow(FALSE);
	GetDlgItem(IDC_START )->EnableWindow(FALSE);
	GetDlgItem(IDC_STOP)->EnableWindow(TRUE);
	GetDlgItem(IDC_JPG)->EnableWindow(TRUE);


	okSetSeqCallback(hBoard,NULL,NULL,NULL);
	okSetSeqCallback(hBoard,BeginCapture,Process,EndCapture);//ûص
	okCaptureTo(hBoard,BUFFER,0,-1);//ʼɼ
	
}

void CCaptureImageDlg::OnTimer(UINT_PTR nIDEvent) 
{
	
	bTrig=okGetSignalParam(hBoard,SIGNAL_EXTTRIGGER);//òɼǰĴ״̬ͷִ֧˹ܣ
	
	CDialog::OnTimer(nIDEvent);
}



void CCaptureImageDlg::OnCheck() 
{
	symbol=!symbol;//޸ĸ־λ
	
}

BOOL exConvertBitmap(LPBITMAPINFOHEADER lpbi,LPSTR lpdib)
{
	long	i,wbytes;
	LPSTR	lpbuf;
	LPSTR	lptop,lpbottom;
	
	if(!lpbi)
		return FALSE;
	if(!lpbi->biHeight)
		return FALSE;
	
	//inverse dib (top to bottom)
	wbytes=lpbi->biSizeImage/lpbi->biHeight;
	lpbuf=(LPSTR)GlobalAlloc(GPTR,wbytes);
	
	lptop=lpdib;
	lpbottom=lpdib+(lpbi->biHeight-1)*wbytes;
	for(i=0;i<lpbi->biHeight/2;i++) {
		CopyMemory(lpbuf,lptop,wbytes);
		CopyMemory(lptop,lpbottom,wbytes);
		CopyMemory(lpbottom,lpbuf,wbytes);
		lptop+=wbytes;
		lpbottom-=wbytes;
	}
	GlobalFree(lpbuf);
	
	return TRUE;
}
